/*
 *  Copyright 2003 Adrian Thurston <adriant@ragel.ca>
 */

/*  This file is part of Ragel.
 *
 *  Ragel is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 * 
 *  Ragel is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 * 
 *  You should have received a copy of the GNU General Public License
 *  along with Ragel; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
 */

#ifndef _PTREETYPES_H
#define _PTREETYPES_H

/* Leaf type. */
struct Literal;

/* Tree nodes. */

struct TermNode;
struct FactorWithRepNode;
struct FactorWithAugNode;
struct FactorWithNegNode;
struct FactorNode;
struct ExpressionNode;

/* Type of augmentation. Describes locations in the machine. */
enum AugType
{
	start,
	fin,
	all,
	leave
};

/* Fsm transition priority descriptor. */
struct PriorDesc;

/* Regular expression types. */
struct RegExp;
struct ReItem;
struct ReOrBlock;
struct ReOrItem;

/* Explicit machine. */
struct ExplicitMachine;

#endif /* _PTREETYPES_H */
